<?php
// $Id: classroom.blocks.inc,v 1.4 2009/12/17 21:24:02 osoh Exp $

/**
 * Builds the 'My courses' block.
 */
function classroom_my_courses_block() {
  global $user;

  $courses = classroom_get_courses_for_user($user);
  $list = array();
  foreach ($courses as $course) {
    $list[] = l($course->title, "classroom/course/$course->nid");
  }

  if (!empty($list)) {
    return theme('item_list', $list);
  }
}

function classroom_my_assignments_block() {
  global $user;
  $courses = classroom_get_courses_for_user($user);
  $list = array();
  foreach ($courses as $course) {
    $last = 5;
    $qry = "SELECT * FROM {node} LEFT JOIN {classroom_assignment} USING (nid) "
      ."WHERE course_nid = %d ORDER BY created DESC LIMIT %d";
    $result = db_query($qry, $course->nid, $last);
    $rows = array();
    while ($assignment = db_fetch_object($result)) {
      if ($assignment->type == 'quiz')
        $rows[] = l($assignment->title, "classroomquiz/$assignment->nid");
      else
        $rows[] = l($assignment->title, "node/$assignment->nid");
    }

    if (empty($rows)) {
      $lst = array( t("There are no assignments for this course yet."));
    } else {
      $lst = $rows;
    }

    $list[] =  theme('item_list', $lst, l($course->title, "classroom/course/".$course->nid));
  }

  if (!empty($list)) {
    return theme('item_list',  $list);
  }
}

/**
 * Builds the 'Topics' block.
 */
function classroom_topics_block() {
  global $user;

  $path = drupal_get_path_alias($_GET['q']);
  $matches = array();
  preg_match("/^classroom\/course\/(\d+)/", $path, $matches);

  $course = node_load(array('nid' => $matches[1]));

  if (classroom_is_user_registered($user, $course)) {
    $topics = classroom_get_topics($course);
    if (!empty($topics)) {
      $topics_list = array();
      foreach ($topics as $topic) {
        $topics_list[] = classroom_topic_link($topic);
      }
      return theme('item_list', $topics_list);
    }
  }
}
